#ifndef NetLoadD_Config_H
#define NetLoadD_Config_H

#include <stdio.h>
#include <string.h>

#include "dll/davelink.h"

#define DEF_Delay 5
#define DEF_Debug 1
#define DEF_Syslog 0
#define DEF_QuitOnError 1
#define DEF_Commentary 1
#define DEF_FileWrite 0
#define DEF_MySQL 0

class TNetLoadD_Config
 {
 public:
 int Delay;
 int Debug;
 int Syslog;
 int QuitOnError;
 int Commentary;
 int FileWrite;
 int MySQL;
 const char* pYN(int x);
 char SQL_Server[254];
 char SQL_Username[254];
 char SQL_Password[254];
 char SQL_Database[254];
 char SQL_Hostname[254];
 char SQL_Hash[254];
 int SQL_DataLoaded;
 void PrintConfig();
 void PrintHelp();
 int FileConfig(char *filename);
 TNetLoadD_Config(int iDelay= DEF_Delay, int iDebug= DEF_Debug, 
	int iSyslog= DEF_Syslog, int iQuitOnError= DEF_QuitOnError);
 int AutoConfig(char **List, int start, int finish);
 //TNetLoadD_Config(char **List, int start, int finish)
 // { AutoConfig(List, start, finish); }
 };

const char* TNetLoadD_Config::pYN(int x)
 {
 if (x==0) return "No";
 else return "Yes";
 }

void TNetLoadD_Config::PrintConfig()
 {
 printf("netloadd Current Configuration Settings:\n");
 printf("Delay\t\t\t%d seconds\n",Delay);
 printf("Debug Mode\t\t%s\n",pYN(Debug));
 printf("Syslog Output\t\t%s\n",pYN(Syslog));
 printf("Quit on Error\t\t%s\n",pYN(QuitOnError));
 printf("Commentary\t\t%s\n",pYN(Commentary));
 printf("File Write\t\t%s\n",pYN(FileWrite));
 printf("MySQL Write\t\t%s\n\n",pYN(MySQL));
 TdlFile *dll=new TdlFile();
 }

TNetLoadD_Config::TNetLoadD_Config(int iDelay, int iDebug, int iSyslog,
	int iQuitOnError)
 {
 MySQL = DEF_MySQL;
 SQL_DataLoaded=0;
 Delay=iDelay;
 Debug=iDebug;
 Syslog=iSyslog;
 QuitOnError=iQuitOnError;
 Commentary= DEF_Commentary;
 FileWrite= DEF_FileWrite;
 }

int TNetLoadD_Config::AutoConfig(char **List, int start, int finish)
 {
 if (start>finish) return 0;
 if (start<0) return 0;
 for (int a=start; a<=finish; a++)
  {
  if (List[a][0]=='d')
   {
   char del[12]={0,0,0,0,0,0,0,0,0,0,0,0};
   strncpy(del,List[a]+1,strlen(List[a])-1);
   Delay=atoi(del);
   if (Delay==0) Delay= DEF_Delay;
   }
  else if (List[a][0]=='f')
   {
   if (FileConfig(List[a]+1)==0)
    {
    printf("Error loading File %s\n",List[a]+1);
    return 0;
    }
   }
  else
   {
   int Opt=0;
   if (List[a][0]=='+') Opt=1;
   else if (List[a][0]=='-') Opt=0;
   else return 0;
   char Option[32];
   for (int zx=0; zx<32; zx++) Option[zx]=0;
   strncpy(Option,List[a]+1,strlen(List[a])-1);
   int o=0;
   //printf("%d:%s\n",Opt,Option);
   if (strcmp(Option,"debug")==0) o='d';
   else if (strcmp(Option,"d")==0) o='d';
   else if (strcmp(Option,"syslog")==0) o='s';
   else if (strcmp(Option,"quitonerror")==0) o='q';
   else if (strcmp(Option,"q")==0) o='q';
   else if (strcmp(Option,"commentary")==0) o='c';
   else if (strcmp(Option,"comment")==0) o='c';
   else if (strcmp(Option,"c")==0) o='c';
   else if (strcmp(Option,"file")==0) o='f';
   else if (strcmp(Option,"help")==0) o='h';
   else if (strcmp(Option,"h")==0) o='h';
   else if (strcmp(Option,"mysql")==0) o='m';
   else if (strcmp(Option,"exit")==0) o='x';
   else if (strcmp(Option,"x")==0) o='x';
   switch (o)
    {
    case 'd': Debug=Opt; break;
    case 's': Syslog=Opt; break;
    case 'q': QuitOnError=Opt; break;
    case 'c': Commentary=Opt; if (Opt==1) PrintConfig(); break;
    case 'f': FileWrite=Opt; break;
    case 'h': PrintHelp(); break;
    case 'm': MySQL=Opt; break;
    case 'x': return 0; break;
    default: return 0;
    }
   }
  }
 }

int TNetLoadD_Config::FileConfig(char *filename)
 {
 TdlFile *dll=new TdlFile();
 if (dll->LoadFromFile(filename)==0) return 0;
 TdlList *mconf=dll->FindList("main");
 if (mconf>0)
  {
  mconf->Reset();
  char **fred;
  char in[1024];
  const char *f;
  while ((f=mconf->Next())!=0)
   {
   strcpy(in,f);
   fred[0]=in;
   AutoConfig(fred,0,0);
   }
  }
 TdlList *sconf=dll->FindList("mysql");
 if (sconf>0)
  {
  sconf->Reset();
  const char *in=sconf->Next();
  if (in!=0) strcpy(SQL_Server,in);
  in=sconf->Next();
  if (in!=0) strcpy(SQL_Username,in);
  in=sconf->Next();
  if (in!=0) strcpy(SQL_Password,in);
  in=sconf->Next();
  if (in!=0) strcpy(SQL_Database,in);
  TdlList *host=dll->FindList("ident");
  if (host>0)
   {
   host->Reset();
   in=host->Next();
   if (in!=0) strcpy(SQL_Hostname,in);
   in=host->Next();
   if (in!=0) strcpy(SQL_Hash,in);
   }
  SQL_DataLoaded=1;
  }
 delete dll;
 return 1;
 }

void TNetLoadD_Config::PrintHelp()
 {
 printf("netloadd %s Help Text\n\n",NLD_Version);
 printf("Usage: netloadd [options] interface\n");
 printf("Example: netloadd d5 eth0\n\n");
 printf("Options are a list of text strings seperated by spaces.\n");
 printf("Most are in the form +/-option to turn that feature on\n");
 printf("or off. The delay option is of the format dX where X is\n");
 printf("the poll delay in seconds to be used.\n\n");
 printf("The f option is followed by a path to a configuration file\n");
 printf("in DaveLinkedList Format eg f/etc/netloadd.dll\n\n");
 printf("Options:\n\n");
 printf("+/- debug/d\t\tTurns verbose debug mode on or off\n\n");
 printf("+/- syslog\t\tTurns syslog output on or off\n\n");
 printf("+/- quitonerror/q\tTurns the quitonerror flag on or off.\n");
 printf("\t\t\tIf QuitOnError is set, the program will\n");
 printf("\t\t\tterminate if it does not find the device\n");
 printf("\t\t\tduring a scan. Turning this feature off will\n");
 printf("\t\t\tnot disable a fatal error upon startup when\n");
 printf("\t\t\tthe device is not present but is useful if you\n");
 printf("\t\t\thave regular linedrops or dial-on-demand.\n\n");
 printf("+/- commentary/c\tTurns on or offthe console commentary mode\n\n");
 printf("+/- file\t\tTurns on or off the output to /tmp/netloadd.DEV\n\n");
 printf("+/- help/h\t\tOn it's own displays Help and Exits with either\n");
 printf("\t\t\toption. With a valid device and other options, it displays\n");
 printf("\t\t\tthis help on startup\n\n");
 printf("+/- exit/x\t\tProduce a Fatal Error in Config Stream at this point\n\n");
 printf("For more detailed information please see the accompnying documentation\n");
 printf("or view the documentation online at www.purplepixie.org/netload/docs\n\n");
 char s[64];
 TdlFile *dll=new TdlFile();
 dll->Version(s);
 printf("netloadd uses DLL (Dave Linked List) Version %s\n",s);
 printf("for it's config file management.\n\n");
 delete dll;
 }



#endif
